/*--------------------------------------------------------------------.
| dirselect.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

int DirSelect (char *prompt, char *buf, int lines, int xpos, int ypos,
	       int mainc, int ddirc)
{
    int iret;
    long vers;
    void *ps = NULL;
    char *p;
    THING_HEADER_EXT *pThing;

    QD_TEXT (39) menustr;
    QD_TEXT (39) rsltstr;
    MENUDSEL d;

    d.mennm.attr = THP_CALL | THP_OPT | THP_STR;
    d.mennm.info = 0;
    d.mennm.ptr = &menustr;
    MOVEIN (menustr, prompt);

    d.lines = lines;
    d.xpos = xpos;
    d.ypos = ypos;
    d.mainc = mainc;
    d.ddirc = ddirc;

    d.fname.attr = THP_RET | THP_STR;
    d.fname.info = 0;
    d.fname.ptr = &rsltstr;
    rsltstr.len = 0;

    iret = (int) sms_uthg ("Menus", -1, -1, &dsel.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	iret = __use_thing (pThing->thh_code, &d);
	if (iret >= 0)
	{
	    RESTORE (buf, (struct QD_text *) &rsltstr);
	}
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
