/*--------------------------------------------------------------------.
| fileerror.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"


long FileError (long errnum, unsigned char optns, int xpos, int ypos, int mainc)
{
    void *ps = NULL;
    long vers;
    int i;
    long iret;
    MENUFERR fe;

    fe.actn.ptr = &iret;
    fe.actn.attr = THP_RET | THP_SLNG;
    fe.actn.info = 0;
    fe.error = errnum;
    fe.optns = optns;
    fe.xpos = xpos;
    fe.ypos = ypos;
    fe.mainc = mainc;

    i = (int) sms_uthg ("Menus", -1, -1, &ferr.x, NULL, &vers, &ps);
    if (i > 0)
    {
	THING_HEADER_EXT *pThing;

	pThing = (THING_HEADER_EXT *) i;
	i = __use_thing (pThing->thh_code, &fe);
	if (i < 0)
	    ReportError (iret = i, 0, 0, -1);
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
