/*--------------------------------------------------------------------.
| clearscrap.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

int ClearScrap (void)
{
    int iret;
    void *ps = NULL;
    long vers;
    THING_HEADER_EXT *pThing;

    iret = (int) sms_uthg ("Scrap Extensions", -1, -1, &clr.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	iret = __use_thing (pThing->thh_code, NULL);
	sms_fthg ("Scrap Extensions", -1, NULL, 0, NULL, NULL);
    }

    return iret;

}
