include /etc/ql.mak

CFLAGS = -O
QLLIB = libhotthg.a

OBJS = hot.o smsfthg.o smslthg.o smsnthg.o smsnthu.o smsrthg.o smsuthg.o smszthg.o

XOBJS= thgtest.o jcall.o
thgtest: $(XOBJS)
	$(CC) -O -o thgtest $(XOBJS) -lhotthg

lib: $(OBJS)
	slb -v -Lslb.tmp $(OBJS)
	tsort slb.tmp >slb.list
	slb -crv -mslb.list $(QLLIB)
	rm -f slb.tmp slb.list
	rm -f scom
 
hotest: hotest.o
	$(CC) -O -o hotest hotest.o -lhotthg 

scom: scom.o
	gcc -O2 -o scom scom.c
	strip scom

hot.o: hot.s scom
	$(CC) -o hot.o -c hot.s
	scom hot.o hot.o "hotthg for c68 v0.05"
