/*--------------------------------------------------------------------.
| itemselect.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"


int ItemSelect (char *name, char *prompt, char *item1, char *item2, char *item3,
		int xpos, int ypos, int mainc)
{
    void *ps = NULL;
    int iret = -1;
    unsigned long *x;
    long vers;
    int i;

    QD_TEXT (39) menustr;
    QD_TEXT (39) prmptstr;
    QD_TEXT (39) item1str;
    QD_TEXT (39) item2str;
    QD_TEXT (39) item3str;
    QD_TEXT (39) rsltstr;

    MENUITSL is;

    if (!item1)			/* before we do any real work */
	return iret;
    else
	MOVEIN (item1str, item1);

    is.xpos = xpos;
    is.ypos = ypos;
    is.mainc = mainc;
    is.retn.attr = THP_RET | THP_ULNG;
    is.retn.info = 0;
    is.retn.ptr = &iret;

    is.mennm.attr = THP_CALL | THP_OPT | THP_STR | THP_SLNG;
    is.mennm.info = 0;
    if((long)name > 0)
    {
	is.mennm.ptr = &menustr;
	MOVEIN (menustr, name);
    }
    else is.mennm.ptr = name;

    is.prmpt.attr = THP_CALL|THP_OPT|THP_STR|THP_UPD;
    is.prmpt.info = 0;
    if ((long)prompt > 0)
    {
	is.prmpt.ptr = &prmptstr;
	MOVEIN (prmptstr, prompt);
    }
    else
    {
	is.prmpt.ptr = prompt;
    }
    is.item1.attr = THP_CALL | THP_STR;
    is.item1.info = 0;
    is.item1.ptr = &item1str;

    is.item2.attr = THP_CALL | THP_OPT | THP_STR;
    is.item2.info = 0;
    if (item2)
    {
	is.item2.ptr = &item2str;
	MOVEIN (item2str, item2);
    }
    else
	is.item2.ptr = NULL;

    is.item3.attr = THP_CALL | THP_OPT | THP_STR;
    is.item3.info = 0;
    if (item3)
    {
	is.item3.ptr = &item3str;
	MOVEIN (item3str, item3);
    }
    else
	is.item3.ptr = NULL;

    i = (int) sms_uthg ("Menus", -1, -1, &itsl.x, NULL, &vers, &ps);
    if (i > 0)
    {
	THING_HEADER_EXT *pThing;

	pThing = (THING_HEADER_EXT *) i;
	i = __use_thing (pThing->thh_code, &is);
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }
    return iret;
}
