/*--------------------------------------------------------------------.
| menuinfo.c							      |
| 								      |
| (c) 1997 Christopher Cave and Jonathan Hudson			      |
| This file is part of the freely distributable menu_rext c68 library |
| It may be distributed under the same terms as c68		      |
| 								      |
| Authors:							      |
|    Christopher Cave    <ccave@cix.compulink.co.uk>		      |
|    Jonathan Hudson     <jrh@jrhudson.demon.co.uk>		      |
`--------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qdos.h>
#include <qptr.h>

#include <things.h>
#include "menu.h"
#include "menuP.h"

char *MenuInfo (long key, char *buf)
{
    int iret;
    long vers;
    THING_HEADER_EXT *pThing;
    void *ps = NULL;

    QD_TEXT (39) rsltstr;

    MENUINFO i;

    i.key = key;
    i.result.attr = THP_RET | THP_STR;
    i.result.info = 0;
    i.result.ptr = &rsltstr;
    rsltstr.len = 0;

    iret = (int) sms_uthg ("Menus", -1, -1, &info.x, NULL, &vers, &ps);
    if (iret > 0)
    {
	pThing = (THING_HEADER_EXT *) iret;
	iret = __use_thing (pThing->thh_code, &i);
	RESTORE (buf, (struct QD_text *) &rsltstr);
	sms_fthg ("Menus", -1, NULL, 0, NULL, NULL);
    }

    return buf;
}
